import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import createSagaMiddleware from 'redux-saga';
import rootSaga from './root_saga';
import emptySaga from './empty_saga';
import createApi from './create_api';

var createResolveMiddleware = function createResolveMiddleware() {
  var sagaMiddleware = createSagaMiddleware();
  var sagaMiddlewareRun = sagaMiddleware.run.bind(sagaMiddleware);

  var sagaRunInternal = function sagaRunInternal(sagaArgs) {
    var api = createApi(sagaArgs);
    var queryIdMap = new Map();
    sagaMiddlewareRun(sagaArgs.isClient ? rootSaga : emptySaga, _objectSpread({}, sagaArgs, {
      queryIdMap: queryIdMap,
      api: api
    }));
  };

  Object.defineProperty(sagaMiddleware, 'run', {
    get: function get() {
      return sagaRunInternal;
    },
    set: function set(value) {
      return sagaMiddlewareRun = value.bind(sagaMiddleware);
    }
  });
  return sagaMiddleware;
};

export default createResolveMiddleware;
//# sourceMappingURL=create_resolve_middleware.js.map